<?php
/**
 * Copyright (c) 2012, BitKassa B.V.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met: 
 * 
 * - Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
 * DAMAGE. 
 *
 * @category    BitKassa
 * @package     BitKassa_Bitcoin
 * @author      BitKassa (info@bitkassa.nl)
 * @version     v1.0 (based on Mollie_Ideal v4.7)
 * @copyright   Copyright (c) 2012 Mollie B.V. (http://www.mollie.nl)
 * @license     http://www.opensource.org/licenses/bsd-license.php  Berkeley Software Distribution License (BSD-License 2)
 * 
 **/

class BitKassa_Model {

    public function getPaymentById ($transaction_id) {
        if (!empty($transaction_id)) {            
            $sql = sprintf(
                    "SELECT *
                     FROM `%sbitkassa_bitcoin_transactions`
                     WHERE `transaction_id` = '%s'", 
                     $prefix, tep_db_prepare_input($transaction_id)
                    );
           $q = tep_db_query($sql);        
           if (count($q) > 0) {
               return tep_db_fetch_array($q);
           }
        }
        return false;
    }

     public function setPayment ($order_id, $transaction_id) {
        if (!empty($order_id) && !empty($transaction_id)) {                    
            $q = tep_db_query(
                sprintf(
                    "INSERT INTO `%sbitkassa_bitcoin_transactions` (`order_id` ,`transaction_id`, `status`)
                     VALUES (%s, '%s', '%s')",
                     $prefix, tep_db_prepare_input($order_id), tep_db_prepare_input($transaction_id), 'open'
                )
            );
            if (count($q) > 0) {
                return true;
            }
        }
        return false;
    }
    
    public function updatePayment ($transaction_id, $status) {
        if (!empty($transaction_id) && !empty($status)) {
            $q = tep_db_query(
                sprintf(
                    "UPDATE `%sbitkassa_bitcoin_transactions` 
                     SET `status` = '%s' 
                     WHERE `transaction_id` = '%s';",
                     $prefix,
                   tep_db_prepare_input($status),
                   tep_db_prepare_input($transaction_id)
                )
            );
            if (count($q) > 0) {
                return true;
            }
        }
        return false;
    }
}